Bug 890568 - PRD33 - [RFE] Branding as external package
PRD33 - [RFE] Branding as external package
Status: CLOSED ERRATA
Product: Red Hat Enterprise Virtualization Manager
Classification: Red Hat
Component: ovirt-engine (Show other bugs)
unspecified
Unspecified Unspecified
high Severity high
: ---
: 3.3.0
Assigned To: Alexander Wels
Pavel Novotny
ux
: FutureFeature
Depends On:
Blocks: 816173 1019470
  Show dependency treegraph
 
Reported: 2012-12-27 14:38 EST by Alon Bar-Lev
Modified: 2015-09-22 09 EDT (History)
18 users (show)

See Also:
Fixed In Version: is2
Doc Type: Enhancement
Doc Text:
This feature provides support for a branding configuration file that allows administrators to configure the look and feel of Red Hat Enterprise Virtualization, including branding, and override certain text displayed to end users. With this feature, administrators can now install an external package that will override logos, titles and certain colors in the welcome page, Administration Portal and User Portal.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-01-21 12:12:08 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
sgrinber: Triaged+


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
oVirt gerrit 13181 None None None Never

  None (edit)
Description Alon Bar-Lev 2012-12-27 14:38:35 EST
CURRENT IMPLEMENTATION

Downstream (rhevm) rebrand product using patch series that modifies upstream files.

Then rhsm rebrand product again, using patch series that modified downstream files.

PROBLEMS IN CURRENT IMPLEMENTATION

Overriding/patching files for branding breaks the branding often as code changes without considering the branding requirements.

Overriding/patching files makes it difficult to brand the product to other various brands, such as customer specific branding.

PROPOSED SOLUTION

Support branding configuration file. This can be a simple properties file to refer to branding resources: images, css, html includes, strings.

A search path will be applied, upstream is at end of list.

Example:

/etc/ovirt-engine/branding/default.properties -> rhevm.properties
/etc/ovirt-engine/branding/rhevm.properties
/etc/ovirt-engine/branding/ovirt-engine.properties

Search path:
/etc/ovirt-engine/branding/default.properties
/etc/ovirt-engine/branding/ovirt-engine.properties

A branding package rhevm-branding should contain all resources and property file. At %post it can have something like that to apply it as default:

 [ -r /etc/ovirt-engine/branding/default.properties ] || \
     ln -s %{name}.properties /etc/ovirt-engine/branding/default.properties

BOTTOM LINE

No branding patches, application should support branding.
Comment 1 Alon Bar-Lev 2013-02-14 00:21:27 EST
Summary of discussion with Alexander Wels.

We require branding inheritance so that we can change selected resources.

Branding location:

/etc/ovirt-engine/branding/@PROFILES@

Logic:

You read all directories under /etc/ovirt-engine/branding
Sort by name.
Construct search path based on list.

Example:

/etc/ovirt-engine/branding/01-user/logo.png
/etc/ovirt-engine/branding/50-rhevm->/usr/share/ovirt-engine/branding/rhevm
/etc/ovirt-engine/branding/99-default->/usr/share/ovirt-engine/branding/default

In this case you fallback to /usr/share/ovirt-engine/branding/default only if /etc/ovirt-engine/branding is missing or empty, as the 99-default will be installed with the ovirt-engine package.

Why we need to fallback? I think that it will be useful for development... not sure, we will revise this when actually construct the layout.

Package should also contain string table that needs branding, not only html resources.

Branding resources should be fetched using servlet, for example: /getBrandingResource?name=logo.png
Comment 4 Pavel Novotny 2013-07-08 06:52:26 EDT
Clearing needinfo flag, answered in comment#3.
Comment 5 Itamar Heim 2013-08-05 10:00:53 EDT
This requires a release note that branding overlays may break on upgrades to newer minor versions. the branding will be stable when in z-stream mode for a minor version.
Comment 6 Pavel Novotny 2013-09-03 05:34:14 EDT
Verified in rhevm-3.3.0-0.18.master.el6ev (IS12).

Support for downstream (RHEVM) branding is working in general. All new bugs found in this feature will be filed as a new bugzilla.
Comment 7 Charlie 2013-11-27 19:16:29 EST
This bug is currently attached to errata RHEA-2013:15231. If this change is not to be documented in the text for this errata please either remove it from the errata, set the requires_doc_text flag to minus (-), or leave a "Doc Text" value of "--no tech note required" if you do not have permission to alter the flag.

Otherwise to aid in the development of relevant and accurate release documentation, please fill out the "Doc Text" field above with these four (4) pieces of information:

* Cause: What actions or circumstances cause this bug to present.
* Consequence: What happens when the bug presents.
* Fix: What was done to fix the bug.
* Result: What now happens when the actions or circumstances above occur. (NB: this is not the same as 'the bug doesn't present anymore')

Once filled out, please set the "Doc Type" field to the appropriate value for the type of change made and submit your edits to the bug.

For further details on the Cause, Consequence, Fix, Result format please refer to:

https://bugzilla.redhat.com/page.cgi?id=fields.html#cf_release_notes 

Thanks in advance.
Comment 9 errata-xmlrpc 2014-01-21 12:12:08 EST
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2014-0038.html

Note You need to log in before you can comment on or make changes to this bug.